// Compiled by ClojureScript 0.0-3308 {:elide-asserts true}
goog.provide('com.dreamsoft.calculator.ui');
goog.require('cljs.core');
goog.require('reagent.core');
goog.require('com.dreamsoft.calculator.eval');
/**
 * A button widget which call the callback with the symbol when pressed
 */
com.dreamsoft.calculator.ui.button = (function com$dreamsoft$calculator$ui$button(symbol,callback){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"button","button",1456579943),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"on-click","on-click",1632826543),(function (){
return callback.call(null,symbol);
}),new cljs.core.Keyword(null,"style","style",-496642736),new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"font-size","font-size",-1847940346),"30px",new cljs.core.Keyword(null,"height","height",1025178622),"200px",new cljs.core.Keyword(null,"width","width",-384071477),"200px"], null)], null),[cljs.core.str(symbol)].join('')], null);
});
/**
 * A raw value display. Used a the screen of the calculator.
 */
com.dreamsoft.calculator.ui.display = (function com$dreamsoft$calculator$ui$display(value){
console.log([cljs.core.str(cljs.core.deref.call(null,value))].join(''));

return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"p","p",151049309),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"style","style",-496642736),new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"background-color","background-color",570434026),"black",new cljs.core.Keyword(null,"color","color",1011675173),"white",new cljs.core.Keyword(null,"font-family","font-family",-667419874),"monospace",new cljs.core.Keyword(null,"font-size","font-size",-1847940346),"40px",new cljs.core.Keyword(null,"padding","padding",1660304693),"20px",new cljs.core.Keyword(null,"text-align","text-align",1786091845),"right"], null)], null),[cljs.core.str(com.dreamsoft.calculator.eval.eval.call(null,cljs.core.deref.call(null,value)))].join('')], null);
});
/**
 * A grid which display the items left to right and left to bottom.
 * The grid can be scrolled on overflow.
 */
com.dreamsoft.calculator.ui.grid = (function com$dreamsoft$calculator$ui$grid(items){
return cljs.core.into.call(null,cljs.core.PersistentVector.EMPTY,cljs.core.concat.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"div","div",1057191632),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"style","style",-496642736),new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"display","display",242065432),"flex",new cljs.core.Keyword(null,"flex-direction","flex-direction",364609438),"row",new cljs.core.Keyword(null,"flex-wrap","flex-wrap",455413707),"wrap",new cljs.core.Keyword(null,"overflow-y","overflow-y",-1436589285),"auto"], null)], null)], null),items));
});
com.dreamsoft.calculator.ui.page = (function com$dreamsoft$calculator$ui$page(value,items){

return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"div","div",1057191632),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"style","style",-496642736),new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"align-items","align-items",-267946462),"stretch",new cljs.core.Keyword(null,"display","display",242065432),"flex",new cljs.core.Keyword(null,"flex","flex",-1425124628),"1",new cljs.core.Keyword(null,"flex-direction","flex-direction",364609438),"column",new cljs.core.Keyword(null,"overflow","overflow",2058931880),"hidden",new cljs.core.Keyword(null,"width","width",-384071477),"100%"], null)], null),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [com.dreamsoft.calculator.ui.display,value], null),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [com.dreamsoft.calculator.ui.grid,items], null)], null);
});
