(defproject com.dreamsoft.calculator "0.1.0-SNAPSHOT"
	:description "A web browser based calculator."
	:dependencies [[org.clojure/clojure "1.7.0"]
	               [org.clojure/clojurescript "0.0-3308"]
	               [reagent "0.5.0"]]
	:plugins [[lein-cljsbuild "1.0.6"]]
	:cljsbuild {
		:builds {
			:dev {
				:source-paths ["src"]
				:compiler {
					:preample [
						"rsc/js/javascript-bignum/biginteger.js"
						"rsc/js/javascript-bignum/schemeNumber.js"]
					:main "com.dreamsoft.calculator.core"
					:output-dir "rsc/js/out"
					:output-to "rsc/js/main.js"
					:optimizations :whitespace
					:elide-asserts true
					:pretty-print true
					:source-map "rsc/js/main.js.map"}}}})
