// Compiled by ClojureScript 0.0-3308 {}
goog.provide('com.dreamsoft.calculator.builder');
goog.require('cljs.core');
goog.require('clojure.zip');
goog.require('com.dreamsoft.calculator.bignum');
com.dreamsoft.calculator.builder.figures = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 10, ["9",null,"3",null,"4",null,"8",null,"7",null,"5",null,"6",null,"1",null,"0",null,"2",null], null), null);
com.dreamsoft.calculator.builder.operators = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 4, ["\u2212",null,"\u00D7",null,"\u00F7",null,"+",null], null), null);
com.dreamsoft.calculator.builder.args_needed = new cljs.core.PersistentArrayMap(null, 4, ["+",(2),"\u2212",(2),"\u00D7",(2),"\u00F7",(2)], null);
com.dreamsoft.calculator.builder.operator_QMARK_ = cljs.core.partial.call(null,cljs.core.contains_QMARK_,com.dreamsoft.calculator.builder.operators);
com.dreamsoft.calculator.builder.open_parenthesis = "(";
com.dreamsoft.calculator.builder.open_parenthesis_QMARK_ = cljs.core.partial.call(null,cljs.core._EQ_,com.dreamsoft.calculator.builder.open_parenthesis);
com.dreamsoft.calculator.builder.close_parenthesis = ")";
com.dreamsoft.calculator.builder.close_parenthesis_QMARK_ = cljs.core.partial.call(null,cljs.core._EQ_,com.dreamsoft.calculator.builder.close_parenthesis);
com.dreamsoft.calculator.builder.digits_QMARK_ = (function com$dreamsoft$calculator$builder$digits_QMARK_(x){
var or__4309__auto__ = /^[0-9]+(\.[0-9]+)?$/.call(null,x);
if(cljs.core.truth_(or__4309__auto__)){
return or__4309__auto__;
} else {
return /^[0-9]+(\/[0-9]+)?$/.call(null,x);
}
});
com.dreamsoft.calculator.builder.top_QMARK_ = cljs.core.comp.call(null,cljs.core.nil_QMARK_,clojure.zip.up);
com.dreamsoft.calculator.builder.node_ast = (function com$dreamsoft$calculator$builder$node_ast(x){
return clojure.zip.vector_zip.call(null,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [x], null));
});
com.dreamsoft.calculator.builder.enough_arguments = (function com$dreamsoft$calculator$builder$enough_arguments(loc){
var symbol = clojure.zip.node.call(null,loc);
var children = clojure.zip.children.call(null,loc);
return (cljs.core.count.call(null,children) >= cljs.core.get.call(null,com.dreamsoft.calculator.builder.args_needed,symbol));
});
com.dreamsoft.calculator.builder.ignore_input = (function com$dreamsoft$calculator$builder$ignore_input(ast,x){
console.log([cljs.core.str("invalid operator '"),cljs.core.str(x),cljs.core.str("' inserted under '"),cljs.core.str(clojure.zip.up.call(null,ast)),cljs.core.str("' with siblings '"),cljs.core.str(clojure.zip.children.call(null,clojure.zip.up.call(null,ast))),cljs.core.str("'")].join(''));

return ast;
});
