// Compiled by ClojureScript 0.0-3308 {:elide-asserts true}
goog.provide('com.dreamsoft.calculator.core');
goog.require('cljs.core');
goog.require('reagent.core');
goog.require('clojure.browser.repl');
goog.require('com.dreamsoft.calculator.ui');
goog.require('com.dreamsoft.calculator.ast');
goog.require('com.dreamsoft.calculator.bignum');
goog.require('com.dreamsoft.calculator.token');
if(typeof com.dreamsoft.calculator.core.state !== 'undefined'){
} else {
com.dreamsoft.calculator.core.state = reagent.core.atom.call(null,com.dreamsoft.calculator.ast.singleton.call(null,"0"));
}
com.dreamsoft.calculator.core.handler = (function com$dreamsoft$calculator$core$handler(symbol){
return cljs.core.swap_BANG_.call(null,com.dreamsoft.calculator.core.state,com.dreamsoft.calculator.ast.insert_token,symbol);
});
com.dreamsoft.calculator.core.buttons = (function (){var iter__5063__auto__ = (function com$dreamsoft$calculator$core$iter__7317(s__7318){
return (new cljs.core.LazySeq(null,(function (){
var s__7318__$1 = s__7318;
while(true){
var temp__4425__auto__ = cljs.core.seq.call(null,s__7318__$1);
if(temp__4425__auto__){
var s__7318__$2 = temp__4425__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,s__7318__$2)){
var c__5061__auto__ = cljs.core.chunk_first.call(null,s__7318__$2);
var size__5062__auto__ = cljs.core.count.call(null,c__5061__auto__);
var b__7320 = cljs.core.chunk_buffer.call(null,size__5062__auto__);
if((function (){var i__7319 = (0);
while(true){
if((i__7319 < size__5062__auto__)){
var symbol = cljs.core._nth.call(null,c__5061__auto__,i__7319);
cljs.core.chunk_append.call(null,b__7320,com.dreamsoft.calculator.ui.button.call(null,symbol,com.dreamsoft.calculator.core.handler));

var G__7321 = (i__7319 + (1));
i__7319 = G__7321;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__7320),com$dreamsoft$calculator$core$iter__7317.call(null,cljs.core.chunk_rest.call(null,s__7318__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__7320),null);
}
} else {
var symbol = cljs.core.first.call(null,s__7318__$2);
return cljs.core.cons.call(null,com.dreamsoft.calculator.ui.button.call(null,symbol,com.dreamsoft.calculator.core.handler),com$dreamsoft$calculator$core$iter__7317.call(null,cljs.core.rest.call(null,s__7318__$2)));
}
} else {
return null;
}
break;
}
}),null,null));
});
return iter__5063__auto__.call(null,cljs.core.concat.call(null,com.dreamsoft.calculator.token.figures,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [com.dreamsoft.calculator.token.dot], null),com.dreamsoft.calculator.token.operators));
})();
com.dreamsoft.calculator.core.main_ = (function com$dreamsoft$calculator$core$main_(){
return reagent.core.render_component.call(null,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [com.dreamsoft.calculator.ui.page,com.dreamsoft.calculator.core.state,com.dreamsoft.calculator.core.buttons], null),document.body);
});
clojure.browser.repl.connect.call(null,"http://localhost:9000/repl");
cljs.core.enable_console_print_BANG_.call(null);
com.dreamsoft.calculator.core.main_.call(null);
