(ns com.dreamsoft.calculator.bignum
  "Exposes the operations that the Javascript's bignum library provides in a
   cleaner way. It is pretty much self-explanatory for now")

(def ^:private scm-num (.-fn js/SchemeNumber))

(def bignum (aget scm-num "string->number"))

(def bignum? (aget scm-num "number?"))
(def bigzero? (aget scm-num "zero?"))
(def int? (aget scm-num "integer?"))
(def ratio? (aget scm-num "rational?"))
(def positive? (aget scm-num "positive?"))
(def negative? (aget scm-num "negative?"))

(def equal? (aget scm-num "="))
(def less-than? (aget scm-num "<"))
(def more-than? (aget scm-num ">"))
(def less-or-equal? (aget scm-num "<="))
(def more-or-equal? (aget scm-num ">="))

(def plus (aget scm-num "+"))
(def minus (aget scm-num "-"))
(def times (aget scm-num "*"))
(def divided (aget scm-num "/"))
(def power (aget scm-num "expt"))
(def abs (aget scm-num "abs"))

(def round (aget scm-num "round"))
(def ->ratio (aget scm-num "rationalize"))

; log, exp, sin, cos, asin, acos, sqrt